/*
 * pointhandler.h
 *
 *  Created on: 10/12/2012
 *      Author: Trei
 */

#ifndef POINTHANDLER_H_
#define POINTHANDLER_H_

#include <wx/gdicmn.h>
#include <wx/ffile.h>
#include <map>
#include <vector>
   using namespace std;


//SuperEasyJSON
//#include "SuperEasyJSON/json.h"

//Libreria jsoncpp
//#include <json/json.h>


//Libreria wxJSON
//#include "wxJSON/jsonreader.cpp"
//#include "wxJSON/jsonwriter.cpp"
//#include "wxJSON/jsonval.cpp"
#include <wx/jsonreader.h>
#include <wx/jsonwriter.h>

class pointhandler
{
private:
	//int 				h_image, w_image;
	//int 				h_resized, w_resized;
	int					h_offpos, w_offpos;
	double				razon, hIn, wIn,dist_med;
	//Tipos
	typedef pair <wxPoint, int> t_pfconundrum; // [Punto|dirt]
	typedef pair <const int, t_pfconundrum> pointframeconundrum; // [Frame|[Punto|dirt]]


	typedef struct valor3puntos{
		wxPoint pto;
		float valor;//anteriormente grados
		wxPoint ant;
		wxPoint post;
		int modo;
		 int grupo;

		valor3puntos(wxPoint thePoint, float theValue, wxPoint thePrev, wxPoint thePost, int theMode,  int theGroup)
		{
			pto=thePoint;
			valor=theValue;
			ant=thePrev;
			post=thePost;
			modo=theMode;
			grupo=theGroup;
		}

	}	gradospto;
		//Los modos son "0 - invisible" "1 - visible" "2 - ngulo conjugado"

	typedef pair <const int, gradospto> gradosconundrum; //[Frame|[Punto,Angulo,Punto anterior,Punto siguiente,Modo]]
	//typedef pair <const int, linelenghtconundrum> lineframeconundrum; //[Frame|[Punto medio,Distancia,Punto anterior,Punto siguiente,Modo]]
	typedef pair <const int, wxString> solonotas; //[Frame|String]
	//Iteradores
	typedef multimap <int, t_pfconundrum> :: iterator iterador;
	typedef multimap <int, t_pfconundrum> :: iterator iteralineas;
	typedef multimap <int, gradospto> :: iterator iteragrados;
	typedef multimap <int, wxString> :: iterator iteranotas;

	//Base de datos con todos los puntos almacenados:
	multimap <int, t_pfconundrum> 		points;
	multimap <int, t_pfconundrum> 		lines;
	multimap <int, gradospto> 			grados;
	multimap <int, wxString> 			notas;

	std::vector< int> gruposdeangulos;
	std::vector< int> gruposderectas;

protected:
	iterador 			pIter;
	iteralineas 		lineIter;
	iteragrados 		gradIter;
	iteranotas			notaIter;
	wxPoint				ref_0;

	//a prueba
	int ngrupos;

public:
	pointhandler();
	//convert
	wxPoint insizePoint(wxPoint);
	wxPoint resizePoint(wxPoint);
	//return offset
	int offsetvertical();
	int offsethorizontal();

	//basic
	int count(int);
	int savePoint(int,wxPoint,bool resize=true);
	int checkDirtyBit(int ,wxPoint );
	wxPoint loadPoint(iterador);
	int erasePoint(int,wxPoint,bool resize=true);
	int loadRange(int,wxPoint*,bool resize=true);
	int loadDirtyRange(int,wxPoint*, int* ,bool resize=true);
	float anglePoints(wxPoint,wxPoint,wxPoint);
	float distanceRef(float , wxPoint );
	float distanceMeasure(wxPoint  );
	void pointRef(wxPoint);
	void razondistancia(float);
	void setforwardIter(iterador,int);
	void setbackwardIter(iterador,int);
	void getReferences(int,int,int,int,int,int);
	int saveJSON(wxString);
	int loadJSON(wxString);
	int angulosJSON2graph(wxString ,std::vector<double>*,std::vector<double>*);
	int clearEverything();
	bool isClose(wxPoint, wxPoint);
	int collateral(int frame,wxPoint punto);


	//grupos
	int cuantosgruposdeangulos();
	int cuantosgruposdeangulos(std::vector< int>**);
	int cuantosgruposderectas();
	int cuantosgruposderectas(std::vector< int>**);
	int nuevogrupodeangulo( int);
	int nuevogrupoderectas( int);


	//rectas

	int countlines();
	//int selectLine(int,wxPoint,bool);
	int markLine(int ,wxPoint );
	int showLines(int* ,float* ,wxPoint*);
	//wxPoint loadLine(iteralineas nodo,int n=0);

	//grados

	int threePoints(int frame,wxPoint punto,wxPoint prev,wxPoint post);
	int threePoints(int frame,wxPoint punto,wxPoint prev,wxPoint post, int grupo, int mode=1);
	int countgrad(int);
	int selectPoint(int,wxPoint);
	int gradsearch(int,wxPoint,bool resize=true);
	int showGrad(int ,float* ,wxPoint*);
	int showGrad(int ,float* ,wxPoint*, int*, int* modes=NULL);
	unsigned int generateHash(const char * string, size_t len);


	//notas

	void agregaNota(int frame, wxString nota);
	void borrarNota(int frame);
	int countnotas(int);
	int countnotas();
	int imprimeNota(int frame, wxString *nota);



} ;


#endif /* POINTHANDLER_H_ */
